*
*   Program..: AChoose.Prg
*   System...: Marvelus.Lib     -    Summer '87 Version
*   Syntax...: AChoose( nTop, nLeft, nRight, nBottom, aArray, ;
*                       [ nPointer ], [ cHeading ] )
*   Where....: nTop, nLeft, nRight, nBottom... are the actual Achoice() scan
*            :                                 coordinates
*            : aArray.....is the array that Achoice is to act on
*            : nPointer...is the pointer value IF Ascan was used, pass at least
*            :            "" if NO pointer value is used
*            : cHeading...is optional, and will put a heading at the top of
*            :            the scrolling lookup box
*            :
*   Copyright:           Simply Marvelous Solutions
*                                Mesa, AZ
*                      (c) 1992 - All Rights Reserved
*
Function AChoose
Parameters nTop, nLeft, nBottom, nRight, aArray, nPointer, cHeading, cColor,;
 cColor1
Private nLoop, nMax, nOldPos, nWindSize, nRetVal, cOldcolor, nCurrent, nNewPos

Cursor(0)

If Type("nPointer") <> "N"
  nPointer = 0
Endif

If Type("cColor") = "U"
  cColor = "n/gr"
Endif

If Type("cColor1") = "U"
  cColor1 = "+w/gr"
Endif

nMax      = Len(aArray)
nOldPos   = 0
cOldcolor = SetColor()

If nBottom >=22
  nBottom = 22
Endif

nWindSize = (nBottom-1) - (nTop+1)

SetColor(cColor)
Explode(nTop-1, nLeft-1, nBottom+1, nRight+3, 10, cColor, 3,"aChooseScr")
@nTop-1,nRight+1 Say ""
@nBottom+1,nRight+1 Say ""
@nTop,nRight+1 to nBottom,nRight+1

If Type("cHeading") = "C"
  SetColor(cColor)
  @nTop-1, nLeft+2 Say ""+Space(Len(cHeading))+""
  SetColor("+gr/n")
  @nTop-1, nLeft+3 Say cHeading
Endif

If M->nPointer > 0
   nCurrent = nPointer
   nNewPos = Int(nWindSize / (nMax / nCurrent))

   If nCurrent = 1
     nNewPos = 0
   ElseIf nCurrent = nMax
     nNewPos = nWindSize
   Endif

   If nOldPos <> nNewPos
     SetColor("+gr/n")

     For nLoop = nTop+1 to nBottom-1
       @nLoop, nRight + 2 Say ""
     Next

     SetColor("+w/n")
     @nTop, nRight + 2 Say ""
     @nBottom, nRight + 2 Say ""
     SetColor("n/n")
     @(nTop+1) + nNewPos, nRight + 2 Say ""
     nOldPos = nNewPos
   Endif

Else
   SetColor("n/n")
   @(nTop+1), nRight + 2 Say ""
   SetColor("+w/n")
   @nTop, nRight + 2 Say ""
   @nBottom, nRight + 2 Say ""
   SetColor("+gr/n")

   For nLoop = nTop + 2 to nBottom-1
     @nLoop, nRight + 2 Say ""
   Next

Endif

nRetVal = 0
SetColor(cColor1 + ",+gr/n")

nRetVal = Achoice(nTop + 1, nLeft, nBottom -1, nRight, aArray, .T.,;
                  "AChoose_Udf", nPointer)
Implode("aChooseScr",20)
SetColor(cOldcolor)
Return(nRetVal)
** Eof........: AChoose.Prg

Function AChoose_Udf
*
*The UDF to control the reference marker and the key reactions of AChoose.Prg
*
Parameters nStatus, nCurrent, nRelative
Private cOldcolor, nRetVal
cOldcolor = SetColor()
nRetVal = 2

Do Case
  Case nStatus = 0
    nNewPos = Int(nWindSize / (nMax / nCurrent))

    If nCurrent = 1
      nNewPos = 0
    ElseIf nCurrent = nMax
      nNewPos = nWindSize
    Endif

    If nOldPos <> nNewPos
      SetColor("+gr/n")
      @(nTop+1) + nOldPos, nRight + 2 Say ""
      SetColor("n/n")
      @(nTop+1) + nNewPos, nRight + 2 Say ""
      nOldPos = nNewPos
    Endif

  Case nStatus = 1 .or. nStatus = 2
    Tone(60,2)

  Case nStatus = 3
    Do Case
      Case LastKey() = 27
        nRetVal = 2

      Case LastKey() = 13
        SetColor("+gr/n")
        @(nTop+1) + nOldPos, nRight + 2 Say ""
        SetColor("n/n")
        nRetVal = 1

      Case LastKey() = 1
        KeyBoard Chr(31)
        nRetVal = 2

      Case LastKey() = 6
        KeyBoard Chr(30)
        nRetVal = 2

      Case Upper(Chr(LastKey())) $ "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"
        nRetVal = 3

    EndCase
EndCase
SetColor(cOldcolor)
Return(nRetVal)
** Eof........: Achoose_Udf.Prg
