*
* Program....: Explode.Prg
* System.....: Marvelus.Lib  -  Summer '87 Version
* Author.....: Michael Clerc
* Date.......: December 27, 1989  -  Re-Written Mon  11-04-1991
* Purpose....: To Simulate an E-X-P-L-O-D-I-N-G Box
*            :
* Syntax.....: See Read.Me File
*            :
* Copyright..:           Simply Marvelous Solutions
*                               Mesa, AZ
*                     (c) 1992 - All Rights Reserved
*
Function Explode
Parameters nTop, nLeft, nBottom, nRight, nDelay, cColor, nStyle, cName
Private nSeed1, nSeed2, nBlowt1, nBlowt2, nBlowt3, nBlowt4, nLoop, lSave, nSpot

If Empty(PCount())
  Return(.F.)
ElseIf Type("nTop") + Type("nLeft") + Type("nBottom") + Type("nRight") != "NNNN"
  Return(.F.)
Endif

nSeed1    = Int((nBottom - nTop) / 2)
nSeed2    = Int((nRight - nLeft) / 2)
nBlowt1   = nTop + nSeed1
nBlowt2   = nLeft + nSeed2
nBlowt3   = nBlowt1
nBlowt4   = nBlowt2
SetColor(cColor)

If PCount() = 8
  Public &cName.[20]
  Afill(&cName.,"")
  &cName.[20]= nTop
  &cName.[19]= nLeft
  &cName.[18]= nBottom
  &cName.[17]= nRight
  &cName.[1] = SaveScreen(nTop, nLeft, nBottom + 2, nRight + 2)
  nSpot      = 2
  lSave = .T.
Else
  lSave = .F.
Endif

If nDelay > 1
  Do While (nBlowt1 > nTop .and. nBlowt2 > nLeft) .and. ;
   (nBlowt3 < nBottom .and. nBlowt4 < nRight)

    If Type("nStyle") = "C"
      @nBlowt1, nBlowt2, nBlowt3, nBlowt4 Box Replicate(nStyle,9)
    ElseIf Type("nStyle") = "N"
      @nBlowt1, nBlowt2, nBlowt3, nBlowt4 Box TypeBox(nStyle)
    Endif

    If lSave
      &cName.[nSpot] = SaveScreen(nTop, nLeft, nBottom + 2, nRight + 2)
      nSpot     = nSpot + 1
    Endif

    For nLoop = 1 to nDelay
    Next

    nBlowt1 = nBlowt1 - 1
    nBlowt2 = nBlowt2 - (nSeed2 / nSeed1)
    nBlowt3 = nBlowt3 + 1
    nBlowt4 = nBlowt4 + (nSeed2 / nSeed1)
  Enddo
Endif
** and now for the shadows
** this is the side
ChgAttr(nBottom, nLeft + 2, nBottom + 1, nRight + If(nRight = 78, 1, 2), 8, 0)
** this is the bottom
ChgAttr(nTop + 1, nRight + 1, nBottom + 1, nRight + If(nRight = 78, 1, 2), 8, 0)

If Type("nStyle") = "C"
  @nTop, nLeft, nBottom, nRight Box Replicate(nStyle,9)
ElseIf Type("nStyle") = "N"
  @nTop, nLeft, nBottom, nRight Box TypeBox(nStyle)
Endif
Return(.T.)
** Eof........: Explode.Prg

*
* Program....: Implode.Prg
* System.....: Marvelus.Lib  -  Summer '87 Version
* Author.....: Michael Clerc
* Date.......: December 27, 1989  -  Re-Written  Mon  11-04-1991
* Purpose....: To Simulate an I-M-P-L-O-D-I-N-G Box
*            :
* Syntax.....: Implode(cName, nDelay)
*            :
* Copyright..:           Simply Marvelous Solutions
*                           Fountain Valley, CA
*                     (c) 1992 - All Rights Reserved
*
Function Implode
Parameters cName, nDelay
Private nXx, nStall

** check to make sure that it was saved, and or NOT released
If Type("&cName.") = "U"
  Return(.T.)
Endif

If Type("nDelay") = "U"
  nDelay = 25
Endif

For nXx = 16 to 1 Step -1
  If Len(&cName.[nXx]) > 0
    RestScreen(&cName.[20], &cName.[19], &cName.[18] + 2, &cName.[17] +;
      2,&cName.[nXx])
    For nStall = 1 to nDelay
    Next
  Endif
Next
Release &cName.
Return(.T.)
*** Eof.......: Implode.Prg
